(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)











(* :Name: OptionsExplorer`*)



(*
Mathematica has too many functions and it is not easy to remember all of their properties. OptionsExplorer provides an interactive tool to simplify the work with options of the functions. It opens a dialog window designed for getting information about functions, selecting their values and inserting the activated options into the editing expression. In addition to the Mathematica default set of options the package introduces alternative and preset options. Alternative options may include several values for a particular option thus any possible combination of alternatives can be selected. Preset options allow choosing extra sets of options.
*)



(* :Copyright: 2006 by Yuri E. Kandrashkin *)

(* ykandras @ brocku.ca *)

(* 
Permission is granted to use and distribute this package for non-commercial 
non-profit purpose except for inclusion in program collections
The file must remain intact.
*)



BeginPackage["OptionsExplorer`"]

AlternativeOptions::"usage"=
  "AlternativeOptions[symb] used by OptionsExplorer to set extra values of options for function symb"

PresetOptions::"usage"=
  "PresetOptions[symb]={set1,set2,set3} are lists of additional preset options used by OptionsExplorer"

OptionsExplorer::"usage"=
  "OptionsExplorer opens interactive dialog palette to get information about options and insert their values into the editing expression."



Get["OptionsExplorer`AlternativeAndPresetOptions`"]

Begin["`Private`"]





AlternativeOptions[s_Symbol]:=Options[s]







PresetOptions[s_Symbol]:={}





makeOptionsTable[h_]:=
  Module[{altOpts,presetOpts,preOpts,lastOpts,optnames,opts1,opts2,opts12,
      opt,val,mma,alt,set1,set2,set3,last},
    altOpts=Select[AlternativeOptions[h],
        (MatchQ[Head[#],Rule|RuleDelayed]&&
              MemberQ[First/@Options[h],First[#],1])&];
    altOpts=
      If[#\[LeftDoubleBracket]2,0\[RightDoubleBracket]=!=Alternatives,
            MapAt[Alternatives,#,{2}],#]&/@altOpts;
    altOpts=Map[HoldForm,altOpts,{3}];
    
    presetOpts=PresetOptions[h];
    presetOpts=Switch[presetOpts,
        {{___?OptionQ}},Join[presetOpts,{{},{}}],
        {{___?OptionQ},{___?OptionQ}},Join[presetOpts,{{}}],
        {{___?OptionQ},{___?OptionQ},{___?OptionQ}},presetOpts,
        {{___?OptionQ},{___?OptionQ},{___?OptionQ},___},Take[presetOpts,3],
        {___?OptionQ},{presetOpts,{},{}},
        _,{{},{},{}}];
    
    Do[preOpts[i]=
        Select[presetOpts\[LeftDoubleBracket]i\[RightDoubleBracket],
          (MatchQ[Head[#],Rule|RuleDelayed]&&
                MemberQ[First/@Options[h],First[#],1])&];
      preOptsQ[i]=preOpts[i]=!={};
      preOpts[i]=MapAt[HoldForm,#,{2}]&/@preOpts[i],{i,3}];
    
    lastOpts=If[Head[LastUsedOptions[h]]=!=List,{},LastUsedOptions[h]];
    
    optnames=First/@altOpts;
    optnames=Join[optnames,Complement[
          
          Union@Flatten@{Table[
                  If[preOpts[i]=!={},First/@preOpts[i],{}],{i,3}],
                If[lastOpts=!={},First/@lastOpts,{}]},
          optnames]];
    
    opts1=Function[{opt},If[#=!={},Sequence@@@#,{}]&@
            (Last/@Cases[altOpts,_[opt,_],{1}])]/@optnames;
    opts2=Function[{opt},If[#=!={},Union[#],{}]&@
            (Last/@
                Cases[{preOpts[1],preOpts[2],preOpts[3],lastOpts},_[
                    opt,_],{2}])]/@optnames;
    opts12=Flatten[{#1,Complement[#2,#1]}]&@@@Transpose[{opts1,opts2}];
    
    Table[
      opt=optnames\[LeftDoubleBracket]i\[RightDoubleBracket];
      
      val=
        Cases[{altOpts,preOpts[1]},_[opt,_],{2}][[1,0]]/.{Rule\[Rule]0,
            RuleDelayed\[Rule]1};
      mma={1,val,0,0};
      alt={1,val,1,0};
      
      val=Cases[preOpts[1],_[opt,_],{1}];
      set1=
        If[val==={},
          mma,{Position[opts12\[LeftDoubleBracket]i\[RightDoubleBracket],
                val\[LeftDoubleBracket]1,
                  2\[RightDoubleBracket]]\[LeftDoubleBracket]1,
              1\[RightDoubleBracket],
            
            val\[LeftDoubleBracket]1,0\[RightDoubleBracket]/.{Rule\[Rule]0,
                RuleDelayed\[Rule]1},1,0}];
      val=Cases[preOpts[2],_[opt,_],{1}];
      set2=
        If[val==={},
          mma,{Position[opts12\[LeftDoubleBracket]i\[RightDoubleBracket],
                val\[LeftDoubleBracket]1,
                  2\[RightDoubleBracket]]\[LeftDoubleBracket]1,
              1\[RightDoubleBracket],
            
            val\[LeftDoubleBracket]1,0\[RightDoubleBracket]/.{Rule\[Rule]0,
                RuleDelayed\[Rule]1},1,0}];
      val=Cases[preOpts[3],_[opt,_],{1}];
      set3=
        If[val==={},
          mma,{Position[opts12\[LeftDoubleBracket]i\[RightDoubleBracket],
                val\[LeftDoubleBracket]1,
                  2\[RightDoubleBracket]]\[LeftDoubleBracket]1,
              1\[RightDoubleBracket],
            
            val\[LeftDoubleBracket]1,0\[RightDoubleBracket]/.{Rule\[Rule]0,
                RuleDelayed\[Rule]1},1,0}];
      
      val=Cases[lastOpts,_[opt,_],{1}];
      last=
        If[val==={},
          mma,{Position[opts12\[LeftDoubleBracket]i\[RightDoubleBracket],
                val\[LeftDoubleBracket]1,
                  2\[RightDoubleBracket]]\[LeftDoubleBracket]1,
              1\[RightDoubleBracket],
            
            val\[LeftDoubleBracket]1,0\[RightDoubleBracket]/.{Rule\[Rule]0,
                RuleDelayed\[Rule]1},1,0}];
      
      {opt,opts12[[i]],set1,set2,set3,mma,alt,last,last}
      
      ,{i,Length[optnames]}]]





makeOptionCell[{nopt_,nset_}]:=
  Module[{opt,n,h,a,c,val,lnk,ls},
    opt=optstable\[LeftDoubleBracket]nopt,1\[RightDoubleBracket];
    {n,h,a,c}=optstable\[LeftDoubleBracket]nopt,nset\[RightDoubleBracket];
    val=optstable\[LeftDoubleBracket]nopt,2,n\[RightDoubleBracket];
    lnk=If[Context[Evaluate[opt]]==="System`","RefGuideLink","AddOnsLink"];
    
    ls=Switch[{a,c},
        {0,0},
        {ButtonBox[StyleBox[opt]],
          ButtonBox[StyleBox[h/.{0->"\[Rule]",1->"\[RuleDelayed]"}]],
          
          ButtonBox[
            StyleBox[
              ToBoxes@optstable\[LeftDoubleBracket]nopt,2,
                  n\[RightDoubleBracket]]]},
        
        {1,0},
        {ButtonBox[StyleBox[opt,FontWeight\[Rule]"Bold"]],
          
          ButtonBox[
            StyleBox[h/.{0->"\[Rule]",1->"\[RuleDelayed]"},
              FontWeight\[Rule]"Bold"]],
          
          ButtonBox[
            StyleBox[
              ToBoxes@optstable\[LeftDoubleBracket]nopt,2,
                  n\[RightDoubleBracket],FontWeight\[Rule]"Bold"]]},
        
        {_,1},
        {ButtonBox[StyleBox[opt]],
          ButtonBox[" : "],
          Table[If[i\[NotEqual]n,
              
              ButtonBox@
                StyleBox[
                  RowBox[{" \[EmptySmallCircle] ",
                      ToBoxes@
                        optstable\[LeftDoubleBracket]nopt,2,
                          i\[RightDoubleBracket]}]],
              
              ButtonBox@
                RowBox[{StyleBox[" \[FilledSmallCircle] ",
                      FontColor\[Rule]RGBColor[0.7,0.2,0.4]],
                    
                    StyleBox[
                      ToBoxes@
                        optstable\[LeftDoubleBracket]nopt,2,
                          i\[RightDoubleBracket],
                      FontWeight\[Rule]"Bold"]}]],{i,
              Length[optstable\[LeftDoubleBracket]nopt,
                  2\[RightDoubleBracket]]}]}
        ];
    ls=If[c\[Equal]0,
        Insert[#1,ButtonData\[Rule]{nopt,#2},-1]&@@@Transpose[{ls,{-1,0,n}}],
        Insert[#1,ButtonData\[Rule]{nopt,#2},-1]&@@@
          
          Transpose[{Flatten@ls,
              Range[-1,
                Length[optstable\[LeftDoubleBracket]nopt,
                    2\[RightDoubleBracket]]]}]];
    
    ls=Prepend[ls,ButtonBox[ToBoxes["[?]"],
          ButtonStyle\[Rule]lnk,
          ButtonData\[RuleDelayed]Evaluate[ToString[opt]]]];
    Cell[BoxData@RowBox@ls,"Text",CellTags\[Rule]ToString[nopt]]
    ]



bbo={
      Active\[Rule]True,
      ButtonFrame\[Rule]"None",
      ButtonFunction\[RuleDelayed](FrontEndExecute[{
                FrontEnd`SetOptions[FrontEnd`ButtonNotebook[],
                  
                  ButtonBoxOptions\[Rule]{ButtonData:>#,
                      Active\[Rule]False}]}]&)};



stynb=Notebook[{
        Cell[StyleData["Notebook"],
          Saveable\[Rule]False,
          WindowFrame->"Palette",
          ShowCellBracket\[Rule]False,
          WindowFloating\[Rule]True,
          WindowElements\[Rule]{"VerticalScrollBar"},
          WindowTitle\[Rule]"Options Selector Dialog",
          WindowSize\[Rule]{500,300},
          ShowCellBracket\[Rule]False,
          CellMargins\[Rule]{{0,0},{0,0}},
          Background\[Rule]RGBColor[0.2,0.7,0.7]],
        
        Cell[StyleData["Subtitle"],
          CellMargins\[Rule]{{20,10},{5,20}},
          FontFamily\[Rule]"Helvetica",
          FontSize\[Rule]18,
          FontWeight->"Bold",
          FontColor\[Rule]GrayLevel[1],
          Background\[Rule]RGBColor[0.2,0.7,0.7]],
        
        Cell[StyleData["Subsubtitle"],FontFamily\[Rule]"Helvetica",
          TextAlignment\[Rule]Right,Background\[Rule]RGBColor[0.8,0.9,0.8],
          FontSize\[Rule]12,
          CellFrameMargins\[Rule]{{20,20},{5,5}},
          
          ButtonBoxOptions\[Rule]{ButtonFrame->"DialogBox",
              Background\[Rule]RGBColor[0.7,0.8,0.8]}],
        
        Cell[StyleData["Text"],FontFamily\[Rule]"Times",
          CellFrameMargins\[Rule]{{20,10},{1,2}},
          Background\[Rule]GrayLevel[0.95]],
        
        Cell[StyleData["RefGuideLink"],StyleMenuListing\[Rule]None,
          ButtonBoxOptions\[Rule]{ButtonFunction\[RuleDelayed](\
FrontEndExecute[{FrontEnd`HelpBrowserLookup["RefGuide",#]}]&)}],
        
        Cell[StyleData["AddOnsLink"],StyleMenuListing\[Rule]None,
          ButtonBoxOptions\[Rule]{ButtonFunction\[RuleDelayed](\
FrontEndExecute[{FrontEnd`HelpBrowserLookup["AddOns",#]}]&)}]
        }];



Clear[wdw];
wdw[s_Symbol,stynb_,bbo_]:=Notebook[{
        Cell[BoxData@
            RowBox@{
                ButtonBox[ToBoxes["[?]"],
                  
                  ButtonStyle\[Rule]
                    If[Context[Evaluate[s]]==="System`","RefGuideLink",
                      "AddOnsLink"],
                  ButtonData\[RuleDelayed]Evaluate[ToString[s]]],
                " Select options of ",ToString[s]},"Subtitle"],
        Cell[BoxData@
            GridBox[{{
                  Sequence@@Table[If[preOptsQ[i],
                        
                        ButtonBox["Set "<>ToString[i],
                          ButtonData->"Set"<>ToString[i]],
                        ""],{i,3}],
                  ButtonBox["All",ButtonData:>"All"],
                  ButtonBox["None",ButtonData:>"None"],
                  ButtonBox["Last",ButtonData:>"Last"]}},
              ColumnSpacings\[Rule]{0.5,0.5,3.5,0.5,0.5},
              ColumnWidths\[Rule]{5}],"Subsubtitle"],
        Sequence@@Table[makeOptionCell[{i,-1}],{i,Length@optstable}],
        Cell[BoxData@
            GridBox[{{
                  ButtonBox["Ok",ButtonData:>"Accept"],
                  ButtonBox["Cancel",ButtonData:>"Cancel"]}},
              ColumnWidths\[Rule]{6}],"Subsubtitle"]},
      ButtonBoxOptions\[Rule]bbo,
      StyleDefinitions\[Rule]stynb
      ];





changeState[{nopt_,i_}]:=
    Module[{n,h,a,c},
      {n,h,a,c}=optstable\[LeftDoubleBracket]nopt,-1\[RightDoubleBracket];
      Which[
        c\[Equal]1&&i>0,
        optstable\[LeftDoubleBracket]nopt,-1\[RightDoubleBracket]={i,h,1,0},
        c\[Equal]0&&i\[Equal]-1,
        optstable\[LeftDoubleBracket]nopt,-1\[RightDoubleBracket]={n,h,
            Mod[a+1,2],c},
        c\[Equal]0&&i\[Equal]0,
        optstable\[LeftDoubleBracket]nopt,-1\[RightDoubleBracket]={n,
            Mod[h+1,2],a,c},
        c\[Equal]0&&i>0,
        optstable\[LeftDoubleBracket]nopt,-1\[RightDoubleBracket]={n,h,0,1}]];

rewriteCell[nb_,bbo_,{nopt_,i_}]:=
    (changeState[{nopt,i}];
      NotebookFind[nb,ToString@nopt,All,CellTags,AutoScroll\[Rule]False];
      NotebookWrite[nb,makeOptionCell[{nopt,-1}]];
      FrontEndExecute[FrontEnd`SetOptions[nb,ButtonBoxOptions\[Rule]bbo]]);

rewriteCell[nb_,bbo_,str_String]:=
    (Do[
        optstable\[LeftDoubleBracket]nopt,-1\[RightDoubleBracket]=
          optstable\[LeftDoubleBracket]nopt,str/.
              {"Set1"\[Rule]3,"Set2"\[Rule]4,"Set3"\[Rule]5,"None"\[Rule]6,
                "All"\[Rule]7,"Last"\[Rule]8}\[RightDoubleBracket];
        NotebookFind[nb,ToString@nopt,All,CellTags,AutoScroll\[Rule]False];
        NotebookWrite[nb,makeOptionCell[{nopt,-1}]],{nopt,
          Length[optstable]}];
      FrontEndExecute[FrontEnd`SetOptions[nb,ButtonBoxOptions\[Rule]bbo]]);

getExpr[nb_]:=
  Module[{sel},
    sel=NotebookRead[nb];
    If[sel==={},
      SelectionMove[nb,All,Word];
      sel=NotebookRead[nb];
      If[sel=!={},
        FrontEndTokenExecute["ExpandSelection"];
        sel=NotebookRead[nb]]];
    If[Head[sel]===Cell,SelectionMove[nb,After,Cell]];
    If[Head[sel]===BoxData,
      Block[{Message},SetAttributes[Message,HoldAll];
        sel=ToExpression[First[sel],StandardForm,HoldForm]];
      If[sel=!=$Failed,
        If[Head[sel]===HoldForm,sel={sel}];
        First[sel]],$Failed]]

insertOpts[oldsel_,opts_List]:=
  Module[{sel},
    sel=getExpr[InputNotebook[]];
    If[sel=!=$Failed&&oldsel===sel,
      sel=Delete[Insert[sel,opts,{1,-1}],{{1,-1,0}}];
      sel=ToBoxes[sel][[1]];
      NotebookWrite[InputNotebook[],sel,After]]];



OptionsExplorer[]:=
  Module[{sel,h,nb,btndata,rul},
    sel=getExpr[InputNotebook[]];
    SelectionMove[InputNotebook[],After,Character];
    If[sel=!=$Failed,
      h=sel[[1,0]];
      optstable=makeOptionsTable[h];
      If[optstable=!={},
        nb=NotebookPut@wdw[h,stynb,bbo];
        While[
          FreeQ[{$Failed,{}},nbopts=Options[nb],1],
          If[MatchQ[ButtonBoxOptions/.nbopts,_?OptionQ|{___?OptionQ}]&&
              Not[Active/.(ButtonBoxOptions/.nbopts)],
            btndata=ButtonData/.(ButtonBoxOptions/.nbopts);
            Which[
              MatchQ[btndata,{_Integer,_Integer}|"None"|"All"|"Last"|
                  "Set1"|"Set2"|"Set3"],
              rewriteCell[nb,bbo,btndata],
              MatchQ[btndata,"Cancel"|"Accept"],NotebookClose[nb];
              ]]];
        
        If[btndata==="Accept",
          LastUsedOptions[h]=
            Flatten@Table[
                
                If[optstable\[LeftDoubleBracket]i,-1,
                      3\[RightDoubleBracket]\[Equal]1,
                  
                  rul=optstable\[LeftDoubleBracket]i,-1,
                        2\[RightDoubleBracket]/.{0\[Rule]Rule,
                        1\[Rule]RuleDelayed};
                  
                  rul@@{optstable\[LeftDoubleBracket]i,1\[RightDoubleBracket],
                      optstable\[LeftDoubleBracket]i,2,
                        optstable\[LeftDoubleBracket]i,-1,
                          1\[RightDoubleBracket]\[RightDoubleBracket]},{}]
                ,{i,Length[optstable]}];
          If[LastUsedOptions[h]=!={},
            insertOpts[sel,Delete[#,{2,0}]&/@LastUsedOptions[h]]]];
        SelectionMove[InputNotebook[],After,Character]
        ]]]

Attributes[OptionsExplorer]={Protected,ReadProtected}



End[];
EndPackage[]